# EvoNetHIV  

This is the current development version of EvoNetHIV, an R package for modeling HIV epidemics and viral evolution in sexual networks. 

The package uses the API (application programming interface) of the R package **EpiModel** (http://www.epimodel.org/), and the methods and syntax from the **statnet** suite of R packages (http://www.statnet.org/).

## Funding  

This project is supported by grants from the National Institutes of Health (NIAD R01AI108490 and NIGMS R01GM125440 (via [MIDAS](https://www.nigms.nih.gov/Research/specificareas/MIDAS/Pages/default.aspx))) and the Center for Studies in Demography and Ecology at the University of Washington (https://csde.washington.edu/). 

## Project members  

* John E. Mittler <jmittler@uw.edu>
* Steven M. Goodreau <goodreau@uw.edu>
* Joshua T. Herbeck <herbeck@uw.edu>
* James T. Murphy <jtm6@uw.edu>
* Kathryn C. Peebles <peebles.kathryn@gmail.com>
* Sarah E. Stansfield <sestans@uw.edu>
* Molly C. Reid <mollyr6@uw.edu>
* Neil F. Abernethy <neila@uw.edu>
* Juandalyn C. Burke <jcburke@uw.edu>
* Geoffrey S. Gottlieb <gottlieb@uw.edu>
* Sam Jenness <samuel.m.jenness@emory.edu>

[Model overview](https://github.com/EvoNetHIV/EvoNet/blob/master/documentation/Model_overview.md)  
[Model details](https://evonethiv.github.io/EvoNetHIV/documentation/Model_details.html)    
[Quick start I: run a simple model](https://github.com/EvoNetHIV/EvoNet/blob/master/documentation/Quick%20start.md)    
[Quick start II: a few more details](https://github.com/EvoNetHIV/EvoNetHIV/blob/master/documentation/Model_Basics_Overview.md)    
[Output plots](https://github.com/EvoNetHIV/EvoNetHIV/blob/master/documentation/output_plots_overview.md)  
[Using loops to run experiments](https://github.com/EvoNetHIV/EvoNetHIV/blob/master/documentation/loops_example.md)  
[Concurrency example](https://github.com/EvoNetHIV/EvoNetHIV/blob/master/documentation/concurrency_example.md)  
[Treatment example](https://github.com/EvoNetHIV/EvoNetHIV/blob/master/documentation/treatment_example.md)  
[Output overview](https://github.com/EvoNetHIV/EvoNetHIV/blob/master/documentation/Output_overview.md)  
[Transmission details](https://github.com/EvoNetHIV/EvoNetHIV/blob/master/documentation/trans_details.md)  
[Viral load and CD4 progression](https://github.com/EvoNetHIV/EvoNetHIV/blob/master/documentation/vlcd4.md)  
[Overview of EvoNet functions](https://github.com/EvoNetHIV/EvoNetHIV/blob/master/documentation/fxn_list.md)  



