## Network structure
Sexual networks can be parameterized for MSM or heterosexual dynamics as well as for additional substructure (e.g, age, risk groups, or other user specified dynamics). Below is an example of a heterosexual network with a mean degree of 0.7 at the start of an epidemic. Colored nodes are infected agents.  

![](https://github.com/EvoNetHIV/EvoNetHIV-Overview/blob/master/img/example_hetero_network.png)

## Viral Load progression overview
At infection, agent's viral load (VL) begins at initial VL value of 1e-4. The following acute phase last 90 days and has an exponential increase to the peak of the acute phase and then a bi-phasic decline to the SPVL value. After the acute phase, the chronic phase begins with viral load at the SPVL and progresses with a slight increase in VL. At the beginning of the AIDS phase (triggered when CD4 counts fall &lt;200), a linear increase to the assumed maximum VL value in AIDS (6.38 log10) starts.

The figure below shows a progression for an agent that has a low SPVL. This results in the chronic phase starting at the low SPVL and a noticeable increase in VL occurs at the beginning of the AIDS stage. 

![](https://github.com/EvoNetHIV/EvoNetHIV-Overview/blob/master/img/vlfig1b.png)

## CD4 progression overview
Categorical values (1,2,3,4), Cori and Pickles, etc.

![](https://github.com/EvoNetHIV/EvoNetHIV-Overview/blob/master/img/cd41b.png)

## Transmission dynamics
Hetero vs. MSM, risk factors (age, STI status, condom use, MSM roles, etc.)

![](https://github.com/EvoNetHIV/EvoNetHIV-Overview/blob/master/img/trans1.png)

![](https://github.com/EvoNetHIV/EvoNetHIV-Overview/blob/master/img/trans2.png)


